<template>
	<el-dialog title="选择试题" v-model="dialogVisible" draggable append-to-body destroy-on-close width="800px">
		<el-form :model="state.queryParams" ref="ruleDialogFormRef" inline @submit.native.prevent :disabled="state.loading" class="ruleDialogForm">
			<el-form-item label="标签" prop="tagIds">
                <el-tree-select
                    v-model="state.queryParams.tagIds"
                    :data="state.tagData"
                    node-key="id"
                    :props="{ label: 'name' }"
                    multiple
                    collapse-tags
                    collapse-tags-tooltip
                    :render-after-expand="false"
                    style="width: 200px;"
                    @change="handleQuery"
                />
            </el-form-item>
            <el-form-item label="难易程度" prop="difficultyLevel">
                <el-select v-model="state.queryParams.difficultyLevel" clearable placeholder="请选择" @change="handleQuery" :disabled="state.loading" style="width: 150px">
                    <el-option key='0' label="容易" :value="0" />
                    <el-option key='1' label="适中" :value="1" />
                    <el-option key='2' label="困难" :value="2" />
                </el-select>
            </el-form-item>
            <!-- <el-form-item label="难易程度" prop="questionType">
                <el-select v-model="state.queryParams.questionType" clearable placeholder="请选择" @change="handleQuery" :disabled="state.tableLoading">
                    <el-option key='0' label="单选题" :value="0" />
                    <el-option key='1' label="多选题" :value="1" />
                    <el-option key='2' label="判断题" :value="2" />
                    <el-option key='3' label="填空题" :value="3" />
                    <el-option key='4' label="问答题" :value="4" />
                </el-select>
            </el-form-item> -->
			<el-form-item>
				<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
				<el-button @click="resetQuery(ruleDialogFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
			</el-form-item>
		</el-form>
		<vxe-table
			border
			:loading="state.loading"
			:data="state.tableData"
			:sort-config="{ remote: true }"
			:column-config="{ resizable: true }"
			:row-config="{ isHover: true, height: 30, keyField: 'id' }"
			ref="tableRef"
			height="300px"
			show-overflow
			:scrollY="{ enabled: true, gt: 100 }"
			@checkbox-change="checkboxChangeEvent"
			:checkbox-config="{ highlight: true, showHeader: false }"
		>
			>
			<vxe-column type="checkbox" fixed="left" width="70" align="center"></vxe-column>
			<vxe-column field="questionTypeDesc" title="题型" width="100"></vxe-column>
            <vxe-column field="difficultyLevelDesc" title="难度" width="100"></vxe-column>
            <vxe-column field="title" title="标题" min-width="150"></vxe-column>
		</vxe-table>
		<pagination
			@pagination="queryList"
			:total="state.total"
			v-model:current-page="state.queryParams.PageIndex"
			v-model:page-size="state.queryParams.PageSize"
			:disabled="state.loading"
		/>
		<template #footer>
			<span class="dialog-footer">
				<el-button @click="dialogVisible = false" class="default-button">取 消</el-button>
				<el-button type="primary" @click="onSubmit" :disabled="!state.tableCheckbox">保 存</el-button>
			</span>
		</template>
	</el-dialog>
</template>

<script lang="ts" setup>
import { defineAsyncComponent, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { formatDate } from '@/utils/formatTime';
import other from '@/utils/other';
import {getQuestionData} from '@/api/examTrain/questionBank';
import { examTagTreeList} from '@/api/examTrain/tag';

const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义子组件向父组件传值/事件
const emit = defineEmits(['choose']);

// 定义变量内容
const state = reactive({
	tableData: [] as any[], // 表格数据
	total: 0, // 总条数
	loading: false, // 加载
	queryParams: {
		PageIndex: 1, // 当前页
		PageSize: 20, // 每页条数
		tagIds: null, // 标签id集合
        difficultyLevel: null, // 难易程度
	},
	tableCheckbox: [] as any [], // 已选择的试题
	tagData: [], // 标签数据
});
const ruleDialogFormRef = ref<FormInstance>(); // 表单
const dialogVisible = ref(false); // 弹窗

// 获取标签数据
const getTagData = async () => {
	try {
		const { result } = await examTagTreeList();
		state.tagData = result ?? [];
	} catch (error) {
	}
};
// 打开弹窗
const openDialog = async (selData: any[]) => {
	dialogVisible.value = true;
	try {
        if (selData) {
			state.tableCheckbox = other.deepClone(selData);
		} else {
			state.tableCheckbox = [];
		}
	    getTagData();
		queryList();
	} catch (error) {
		console.log(error);
		state.loading = false;
	}
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
const tableRef = ref<RefType>();
const queryList = () => {
	state.loading = true;
	getQuestionData(state.queryParams)
		.then((res: any) => {
			state.tableData = res.result?.items ?? [];
			state.total = res.result?.pagination.totalCount ?? 0;
			state.loading = false;
            const rows = [] as any[];
            state.tableCheckbox.forEach(item => {
                rows.push(state.tableData.find(it => it.id === item.questionId));
            })
            tableRef.value.setCheckboxRow(rows, true);
		})
		.catch(() => {
			state.loading = false;
		});
};
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	handleQuery();
};
// 单个复选框点击
const checkboxChangeEvent = ({row}) => {
    let blog = 'add';
    state.tableCheckbox.forEach(item => {
        if(item.questionId == row.id){
            blog = 'delete'
        }
    });
    if (blog == 'add'){
        const rowObj = other.deepClone(row);
        rowObj.questionId = rowObj.id;
        Reflect.deleteProperty(rowObj, 'id');
        state.tableCheckbox.push(rowObj)
    }else {
        state.tableCheckbox = state.tableCheckbox.filter(it => it.questionId !== row.id )
    }
}
// 关闭弹窗
const closeDialog = () => {
	dialogVisible.value = false;
};
// 选择试题
const onSubmit = () => {
	emit('choose', state.tableCheckbox);
	closeDialog();
};
//暴漏变量和方法
defineExpose({ closeDialog, openDialog });
</script>
<style>
.el-form--inline.ruleDialogForm .el-form-item .el-select {
    min-width: 100px;
}
</style>
